<template>
    <div class="content">
        <div class="header">
            <h1 class="center-text">{{ appTitle }}</h1>
        </div>
        <div class="alert" v-show="mensagem || loadFotosError">
            <p class="center-text" v-show="mensagem">{{ mensagem }}</p>
            <p class="center-text" v-show="loadFotosError">Não foi possível obter as fotos. <a href="#" @click.prevent="carregaFotos()">Tente novamente</a> mais tarde.</p>
        </div>
        <div class="search" v-show="fotos.length">
            <div class="control">
                <input type="search" class="filtro" placeholder="Filtrar pelo título" @input="filtro = $event.target.value" />
            </div>
            <div class="info" v-show="!!filtro">
                Buscando por "{{ filtro }}"
            </div>
        </div>
        <ul class="ul-fotos">
            <li class="item" :data-id="foto._id" :key="foto._id" v-for="foto of fotosComFiltro">
                <meu-painel :titulo="foto.titulo">
                    <img v-meu-transform:scale="{ incremento: 1.4 }" :src="foto.url" :alt="foto.titulo" />
                    <router-link :to="{ name: 'alterar', params: { id : foto._id } }">
                        <meu-botao 
                            rotulo="Alterar" 
                            tipo="button"/>
                    </router-link>  
                    <meu-botao tipo="button" rotulo="Excluir" @botaoAtivado="removeFoto($event, foto)" :confirmacao="true" estilo="perigo"></meu-botao>
                </meu-painel>
            </li>
        </ul>
        <div class="footer">
            Copyright 2018
        </div>
    </div>
</template>

<script>
import Painel from '../shared/painel/Painel.vue';
import Botao from '../shared/botao/Botao.vue';
import FotoService from '../../domain/foto/FotoService';

export default {
	components: {
		'meu-painel': Painel,
		'meu-botao': Botao,
	},
	data () {
		return {
			appTitle: 'Pics',
			fotos: [],
            filtro: '',
            mensagem: '',
            loadFotosError: false
		}
    },
    created () {
        this.service = new FotoService(this.$resource);
        this.carregaFotos();
    },
	computed: {
		fotosComFiltro() {
			if (this.filtro) {
				let exp = new RegExp(this.filtro.trim(), 'i');
				return this.fotos.filter(foto => exp.test(foto.titulo));
			} else {
				return this.fotos;
			}
		}
    },
    methods: {
        carregaFotos() {
            this.service.lista()
                .then(fotos => {
                    this.fotos = fotos;
                    this.loadFotosError = false;
                }, err => {
                    console.log(err.message);
                    this.loadFotosError = true;
                });
        },
        removeFoto($event, foto) {
            this.service.apaga(foto._id)
                .then(() => {
                    let indice = this.fotos.indexOf(foto);

                    this.fotos.splice(indice, 1);

                    this.mensagem = 'Foto removida com sucesso!'
                }, err => {
                    this.mensagem = err.message;
                    console.log(err)
                });
        }
    }
}
</script>

<style lang="scss">
    .search {
        padding: 20px 0;
        
        .info {
            padding: 10px 0;
        }
    }
    .filtro {
        display: block;
        width: 40%;
        margin: 0 auto;
        border-radius: 5px;
        border: 1px solid #999;
        padding: 10px;
        font-size: 14px;
    }
    .ul-fotos {
        list-style-type: none;
        text-align: left;

        li {
            display: inline-block;
            vertical-align: top;
            box-sizing: border-box;
            text-align: center;
            padding: 10px;
            width: 25%;
        }
    }
</style>
